#include <cpu.h>
#include <idt.h>
#include <types.h>

static IDTDescriptor idtDescriptor;
static IDTEntry idtEntries[256];

#define ISR(i) extern void isr##i()
#define SET_ENTRY(i) idtSetInterruptEntry(i, 0x0008 /* SEG_CODE32_KERNEL */, (uintptr_t)isr##i, 0x0E)

ISR(0);
ISR(1);
ISR(2);
ISR(3);
ISR(4);
ISR(5);
ISR(6);
ISR(7);
ISR(8);
ISR(9);

ISR(10);
ISR(11);
ISR(12);
ISR(13);
ISR(14);
ISR(15);
ISR(16);
ISR(17);
ISR(18);
ISR(19);

ISR(20);
ISR(21);
ISR(22);
ISR(23);
ISR(24);
ISR(25);
ISR(26);
ISR(27);
ISR(28);
ISR(29);

ISR(30);
ISR(31);
ISR(32);
ISR(33);
ISR(34);
ISR(35);
ISR(36);
ISR(37);
ISR(38);
ISR(39);

ISR(40);
ISR(41);
ISR(42);
ISR(43);
ISR(44);
ISR(45);
ISR(46);
ISR(47);
ISR(48);
ISR(49);

ISR(50);
ISR(51);
ISR(52);
ISR(53);
ISR(54);
ISR(55);
ISR(56);
ISR(57);
ISR(58);
ISR(59);

ISR(60);
ISR(61);
ISR(62);
ISR(63);
ISR(64);
ISR(65);
ISR(66);
ISR(67);
ISR(68);
ISR(69);

ISR(70);
ISR(71);
ISR(72);
ISR(73);
ISR(74);
ISR(75);
ISR(76);
ISR(77);
ISR(78);
ISR(79);

ISR(80);
ISR(81);
ISR(82);
ISR(83);
ISR(84);
ISR(85);
ISR(86);
ISR(87);
ISR(88);
ISR(89);

ISR(90);
ISR(91);
ISR(92);
ISR(93);
ISR(94);
ISR(95);
ISR(96);
ISR(97);
ISR(98);
ISR(99);

ISR(100);
ISR(101);
ISR(102);
ISR(103);
ISR(104);
ISR(105);
ISR(106);
ISR(107);
ISR(108);
ISR(109);

ISR(110);
ISR(111);
ISR(112);
ISR(113);
ISR(114);
ISR(115);
ISR(116);
ISR(117);
ISR(118);
ISR(119);

ISR(120);
ISR(121);
ISR(122);
ISR(123);
ISR(124);
ISR(125);
ISR(126);
ISR(127);
ISR(128);
ISR(129);

ISR(130);
ISR(131);
ISR(132);
ISR(133);
ISR(134);
ISR(135);
ISR(136);
ISR(137);
ISR(138);
ISR(139);

ISR(140);
ISR(141);
ISR(142);
ISR(143);
ISR(144);
ISR(145);
ISR(146);
ISR(147);
ISR(148);
ISR(149);

ISR(150);
ISR(151);
ISR(152);
ISR(153);
ISR(154);
ISR(155);
ISR(156);
ISR(157);
ISR(158);
ISR(159);

ISR(160);
ISR(161);
ISR(162);
ISR(163);
ISR(164);
ISR(165);
ISR(166);
ISR(167);
ISR(168);
ISR(169);

ISR(170);
ISR(171);
ISR(172);
ISR(173);
ISR(174);
ISR(175);
ISR(176);
ISR(177);
ISR(178);
ISR(179);

ISR(180);
ISR(181);
ISR(182);
ISR(183);
ISR(184);
ISR(185);
ISR(186);
ISR(187);
ISR(188);
ISR(189);

ISR(190);
ISR(191);
ISR(192);
ISR(193);
ISR(194);
ISR(195);
ISR(196);
ISR(197);
ISR(198);
ISR(199);

ISR(200);
ISR(201);
ISR(202);
ISR(203);
ISR(204);
ISR(205);
ISR(206);
ISR(207);
ISR(208);
ISR(209);

ISR(210);
ISR(211);
ISR(212);
ISR(213);
ISR(214);
ISR(215);
ISR(216);
ISR(217);
ISR(218);
ISR(219);

ISR(220);
ISR(221);
ISR(222);
ISR(223);
ISR(224);
ISR(225);
ISR(226);
ISR(227);
ISR(228);
ISR(229);

ISR(230);
ISR(231);
ISR(232);
ISR(233);
ISR(234);
ISR(235);
ISR(236);
ISR(237);
ISR(238);
ISR(239);

ISR(240);
ISR(241);
ISR(242);
ISR(243);
ISR(244);
ISR(245);
ISR(246);
ISR(247);
ISR(248);
ISR(249);

ISR(250);
ISR(251);
ISR(252);
ISR(253);
ISR(254);
ISR(255);

void idtSetInterruptEntry(uint8_t i, uint16_t sel, uintptr_t offset, uint8_t type)
{
    IDTEntry *entry = &idtDescriptor.Entries[i];
    entry->Interrupt.Offset15_0 = offset & 0xFFFF;
    entry->Interrupt.Selector = sel;
    entry->Interrupt.Zero = 0;
    entry->Interrupt.Type = type & 0x0F;
    entry->Interrupt.DPL = (i < 32) ? 3 : 0; // exceptions may be called from usermode
    entry->Interrupt.P = 1;
    entry->Interrupt.Offset31_16 = (offset >> 16) & 0xFFFF;
}

void idtInitialize()
{
    idtDescriptor.Limit = sizeof(idtEntries) - 1;
    idtDescriptor.Entries = idtEntries;

    SET_ENTRY(0);
    SET_ENTRY(1);
    SET_ENTRY(2);
    SET_ENTRY(3);
    SET_ENTRY(4);
    SET_ENTRY(5);
    SET_ENTRY(6);
    SET_ENTRY(7);
    SET_ENTRY(8);
    SET_ENTRY(9);

    SET_ENTRY(10);
    SET_ENTRY(11);
    SET_ENTRY(12);
    SET_ENTRY(13);
    SET_ENTRY(14);
    SET_ENTRY(15);
    SET_ENTRY(16);
    SET_ENTRY(17);
    SET_ENTRY(18);
    SET_ENTRY(19);

    SET_ENTRY(20);
    SET_ENTRY(21);
    SET_ENTRY(22);
    SET_ENTRY(23);
    SET_ENTRY(24);
    SET_ENTRY(25);
    SET_ENTRY(26);
    SET_ENTRY(27);
    SET_ENTRY(28);
    SET_ENTRY(29);

    SET_ENTRY(30);
    SET_ENTRY(31);
    SET_ENTRY(32);
    SET_ENTRY(33);
    SET_ENTRY(34);
    SET_ENTRY(35);
    SET_ENTRY(36);
    SET_ENTRY(37);
    SET_ENTRY(38);
    SET_ENTRY(39);

    SET_ENTRY(40);
    SET_ENTRY(41);
    SET_ENTRY(42);
    SET_ENTRY(43);
    SET_ENTRY(44);
    SET_ENTRY(45);
    SET_ENTRY(46);
    SET_ENTRY(47);
    SET_ENTRY(48);
    SET_ENTRY(49);

    SET_ENTRY(50);
    SET_ENTRY(51);
    SET_ENTRY(52);
    SET_ENTRY(53);
    SET_ENTRY(54);
    SET_ENTRY(55);
    SET_ENTRY(56);
    SET_ENTRY(57);
    SET_ENTRY(58);
    SET_ENTRY(59);

    SET_ENTRY(60);
    SET_ENTRY(61);
    SET_ENTRY(62);
    SET_ENTRY(63);
    SET_ENTRY(64);
    SET_ENTRY(65);
    SET_ENTRY(66);
    SET_ENTRY(67);
    SET_ENTRY(68);
    SET_ENTRY(69);

    SET_ENTRY(70);
    SET_ENTRY(71);
    SET_ENTRY(72);
    SET_ENTRY(73);
    SET_ENTRY(74);
    SET_ENTRY(75);
    SET_ENTRY(76);
    SET_ENTRY(77);
    SET_ENTRY(78);
    SET_ENTRY(79);

    SET_ENTRY(80);
    SET_ENTRY(81);
    SET_ENTRY(82);
    SET_ENTRY(83);
    SET_ENTRY(84);
    SET_ENTRY(85);
    SET_ENTRY(86);
    SET_ENTRY(87);
    SET_ENTRY(88);
    SET_ENTRY(89);

    SET_ENTRY(90);
    SET_ENTRY(91);
    SET_ENTRY(92);
    SET_ENTRY(93);
    SET_ENTRY(94);
    SET_ENTRY(95);
    SET_ENTRY(96);
    SET_ENTRY(97);
    SET_ENTRY(98);
    SET_ENTRY(99);

    SET_ENTRY(100);
    SET_ENTRY(101);
    SET_ENTRY(102);
    SET_ENTRY(103);
    SET_ENTRY(104);
    SET_ENTRY(105);
    SET_ENTRY(106);
    SET_ENTRY(107);
    SET_ENTRY(108);
    SET_ENTRY(109);

    SET_ENTRY(110);
    SET_ENTRY(111);
    SET_ENTRY(112);
    SET_ENTRY(113);
    SET_ENTRY(114);
    SET_ENTRY(115);
    SET_ENTRY(116);
    SET_ENTRY(117);
    SET_ENTRY(118);
    SET_ENTRY(119);

    SET_ENTRY(120);
    SET_ENTRY(121);
    SET_ENTRY(122);
    SET_ENTRY(123);
    SET_ENTRY(124);
    SET_ENTRY(125);
    SET_ENTRY(126);
    SET_ENTRY(127);
    SET_ENTRY(128);
    SET_ENTRY(129);

    SET_ENTRY(130);
    SET_ENTRY(131);
    SET_ENTRY(132);
    SET_ENTRY(133);
    SET_ENTRY(134);
    SET_ENTRY(135);
    SET_ENTRY(136);
    SET_ENTRY(137);
    SET_ENTRY(138);
    SET_ENTRY(139);

    SET_ENTRY(140);
    SET_ENTRY(141);
    SET_ENTRY(142);
    SET_ENTRY(143);
    SET_ENTRY(144);
    SET_ENTRY(145);
    SET_ENTRY(146);
    SET_ENTRY(147);
    SET_ENTRY(148);
    SET_ENTRY(149);

    SET_ENTRY(150);
    SET_ENTRY(151);
    SET_ENTRY(152);
    SET_ENTRY(153);
    SET_ENTRY(154);
    SET_ENTRY(155);
    SET_ENTRY(156);
    SET_ENTRY(157);
    SET_ENTRY(158);
    SET_ENTRY(159);

    SET_ENTRY(160);
    SET_ENTRY(161);
    SET_ENTRY(162);
    SET_ENTRY(163);
    SET_ENTRY(164);
    SET_ENTRY(165);
    SET_ENTRY(166);
    SET_ENTRY(167);
    SET_ENTRY(168);
    SET_ENTRY(169);

    SET_ENTRY(170);
    SET_ENTRY(171);
    SET_ENTRY(172);
    SET_ENTRY(173);
    SET_ENTRY(174);
    SET_ENTRY(175);
    SET_ENTRY(176);
    SET_ENTRY(177);
    SET_ENTRY(178);
    SET_ENTRY(179);

    SET_ENTRY(180);
    SET_ENTRY(181);
    SET_ENTRY(182);
    SET_ENTRY(183);
    SET_ENTRY(184);
    SET_ENTRY(185);
    SET_ENTRY(186);
    SET_ENTRY(187);
    SET_ENTRY(188);
    SET_ENTRY(189);

    SET_ENTRY(190);
    SET_ENTRY(191);
    SET_ENTRY(192);
    SET_ENTRY(193);
    SET_ENTRY(194);
    SET_ENTRY(195);
    SET_ENTRY(196);
    SET_ENTRY(197);
    SET_ENTRY(198);
    SET_ENTRY(199);

    SET_ENTRY(200);
    SET_ENTRY(201);
    SET_ENTRY(202);
    SET_ENTRY(203);
    SET_ENTRY(204);
    SET_ENTRY(205);
    SET_ENTRY(206);
    SET_ENTRY(207);
    SET_ENTRY(208);
    SET_ENTRY(209);

    SET_ENTRY(210);
    SET_ENTRY(211);
    SET_ENTRY(212);
    SET_ENTRY(213);
    SET_ENTRY(214);
    SET_ENTRY(215);
    SET_ENTRY(216);
    SET_ENTRY(217);
    SET_ENTRY(218);
    SET_ENTRY(219);

    SET_ENTRY(220);
    SET_ENTRY(221);
    SET_ENTRY(222);
    SET_ENTRY(223);
    SET_ENTRY(224);
    SET_ENTRY(225);
    SET_ENTRY(226);
    SET_ENTRY(227);
    SET_ENTRY(228);
    SET_ENTRY(229);

    SET_ENTRY(230);
    SET_ENTRY(231);
    SET_ENTRY(232);
    SET_ENTRY(233);
    SET_ENTRY(234);
    SET_ENTRY(235);
    SET_ENTRY(236);
    SET_ENTRY(237);
    SET_ENTRY(238);
    SET_ENTRY(239);

    SET_ENTRY(240);
    SET_ENTRY(241);
    SET_ENTRY(242);
    SET_ENTRY(243);
    SET_ENTRY(244);
    SET_ENTRY(245);
    SET_ENTRY(246);
    SET_ENTRY(247);
    SET_ENTRY(248);
    SET_ENTRY(249);

    SET_ENTRY(250);
    SET_ENTRY(251);
    SET_ENTRY(252);
    SET_ENTRY(253);
    SET_ENTRY(254);
    SET_ENTRY(255);

    cpuLIDT(&idtDescriptor);
}

