#ifndef VM86_H
#define VM86_H

typedef struct VM86Regs
{
    union
    {
        dword EAX;
        word AX;
        struct
        {
            byte AL;
            byte AH;
        };
    };
    union
    {
        dword EBX;
        word BX;
        struct
        {
            byte BL;
            byte BH;
        };
    };
    union
    {
        dword ECX;
        word CX;
        struct
        {
            byte CL;
            byte CH;
        };
    };
    union
    {
        dword EDX;
        word DX;
        struct
        {
            byte DL;
            byte DH;
        };
    };
    union
    {
        dword ESI;
        word SI;
    };
    union
    {
        dword EDI;
        word DI;
    };
    union
    {
        dword EBP;
        word BP;
    };
    dword DS;
    dword ES;
    dword FS;
    dword GS;
} VM86Regs;

void vm86Initialize();
void vm86Enter(word ss, word sp, word cs, word ip, uint32_t arg);
void vm86Int(byte intNo, VM86Regs *regs);

#endif // VM86_H

